aubio: spectral/specdesc.h File Reference

aubio 0.4.9

Loading...
Searching...
No Matches
Typedefs | Functions
specdesc.h File Reference

Spectral description functions. More...

Go to the source code of this file.

## Typedefs
typedef struct _aubio_specdesc_t | aubio_specdesc_t
| spectral description structure

## Functions
void | aubio_specdesc_do (aubio_specdesc_t *o, const cvec_t *fftgrain, fvec_t *desc)
| execute spectral description function on a spectral frame
aubio_specdesc_t * | new_aubio_specdesc (const char_t *method, uint_t buf_size)
| creation of a spectral description object
void | del_aubio_specdesc (aubio_specdesc_t *o)
| deletion of a spectral descriptor

## Detailed Description

Spectral description functions.

All of the following spectral description functions take as arguments the FFT of a windowed signal (as created with aubio_pvoc). They output one smpl_t per buffer (stored in a vector of size [1]).

# Spectral description functions

A list of the spectral description methods currently available follows.

## Onset detection functions

These functions are designed to raise at notes attacks in music signals.

`energy` : Energy based onset detection function

This function calculates the local energy of the input spectral frame.

`hfc` : High Frequency Content onset detection function

This method computes the High Frequency Content (HFC) of the input spectral frame. The resulting function is efficient at detecting percussive onsets.

Paul Masri. Computer modeling of Sound for Transformation and Synthesis of Musical Signal. PhD dissertation, University of Bristol, UK, 1996.

`complex` : Complex Domain Method onset detection function

Christopher Duxbury, Mike E. Davies, and Mark B. Sandler. Complex domain onset detection for musical signals. In Proceedings of the Digital Audio Effects Conference, DAFx-03, pages 90-93, London, UK, 2003.

`phase` : Phase Based Method onset detection function

Juan-Pablo Bello, Mike P. Davies, and Mark B. Sandler. Phase-based note onset detection for music signals. In Proceedings of the IEEE International Conference on Acoustics Speech and Signal Processing, pages 441444, Hong-Kong, 2003.

`wphase` : Weighted Phase Deviation onset detection function

S. Dixon. Onset detection revisited. In Proceedings of the 9th International Conference on Digital Audio Ef- fects (DAFx) , pages 133–137, 2006.

http://www.eecs.qmul.ac.uk/~simond/pub/2006/dafx.pdf

`specdiff` : Spectral difference method onset detection function

Jonhatan Foote and Shingo Uchihashi. The beat spectrum: a new approach to rhythm analysis. In IEEE International Conference on Multimedia and Expo (ICME 2001), pages 881884, Tokyo, Japan, August 2001.

`kl` : Kullback-Liebler onset detection function

Stephen Hainsworth and Malcom Macleod. Onset detection in music audio signals. In Proceedings of the International Computer Music Conference (ICMC), Singapore, 2003.

`mkl` : Modified Kullback-Liebler onset detection function

Paul Brossier, `‘Automatic annotation of musical audio for interactive systems’', Chapter 2, Temporal segmentation, PhD thesis, Centre for Digital music, Queen Mary University of London, London, UK, 2006.

`specflux` : Spectral Flux

Simon Dixon, Onset Detection Revisited, in `‘Proceedings of the 9th International Conference on Digital Audio Effects’' (DAFx-06), Montreal, Canada, 2006.

## Spectral shape descriptors

The following descriptors are described in:

Geoffroy Peeters, A large set of audio features for sound description (similarity and classification) in the CUIDADO project, CUIDADO I.S.T. Project Report 2004 (pdf)

`centroid` : Spectral centroid

The spectral centroid represents the barycenter of the spectrum.

Note: This function returns the result in bin. To get the spectral centroid in Hz, aubio_bintofreq() should be used.

`spread` : Spectral spread

The spectral spread is the variance of the spectral distribution around its centroid.

See also Standard deviation on Wikipedia.

`skewness` : Spectral skewness

Similarly, the skewness is computed from the third order moment of the spectrum. A negative skewness indicates more energy on the lower part of the spectrum. A positive skewness indicates more energy on the high frequency of the spectrum.

See also Skewness on Wikipedia.

`kurtosis` : Spectral kurtosis

The kurtosis is a measure of the flatness of the spectrum, computed from the fourth order moment.

See also Kurtosis on Wikipedia.

`slope` : Spectral slope

The spectral slope represents decreasing rate of the spectral amplitude, computed using a linear regression.

`decrease` : Spectral decrease

The spectral decrease is another representation of the decreasing rate, based on perceptual criteria.

`rolloff` : Spectral roll-off

This function returns the bin number below which 95% of the spectrum energy is found.

Definition in file specdesc.h.

## Typedef Documentation

## ◆ aubio_specdesc_t

typedef struct _aubio_specdesc_t aubio_specdesc_t

spectral description structure

Definition at line 163 of file specdesc.h.

## Function Documentation

## ◆ aubio_specdesc_do()

void aubio_specdesc_do | ( | aubio_specdesc_t * | o,
|  | const cvec_t * | fftgrain,
|  | fvec_t * | desc
| ) |  |

execute spectral description function on a spectral frame

Generic function to compute spectral description.

Parameters

  o | spectral description object as returned by new_aubio_specdesc()
  fftgrain | input signal spectrum as computed by aubio_pvoc_do
  desc | output vector (one sample long, to send to the peak picking)

Examples
  spectral/test-specdesc.c.

## ◆ del_aubio_specdesc()

void del_aubio_specdesc | ( | aubio_specdesc_t * | o | ) |

deletion of a spectral descriptor

Parameters

  o | spectral descriptor object as returned by new_aubio_specdesc()

Examples
  spectral/test-specdesc.c.

## ◆ new_aubio_specdesc()

aubio_specdesc_t * new_aubio_specdesc | ( | const char_t * | method,
|  | uint_t | buf_size
| ) |  |

creation of a spectral description object

Parameters

  method | spectral description method
  buf_size | length of the input spectrum frame

The parameter `method` is a string that can be any of:

- onset novelty functions: `complex`, `energy`, `hfc`, `kl`, `mkl`, `phase`, `specdiff`, `specflux`, `wphase`,
- spectral descriptors: `centroid`, `decrease`, `kurtosis`, `rolloff`, `skewness`, `slope`, `spread`.

Examples
  spectral/test-specdesc.c.